<?

 /*************************************************************************************
 * Filename: dashboard.php
 *
 * This file is part of the Dashboard JAS plugin.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The Dashboard JAS plugin is free software under the terms of the
 * GNU General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the plugin or http://jas.junerules.com/plugins/dashboard/
 *************************************************************************************/


 require_once($_path["include"]."functions.php");
 require_once($_path["include"]."data.php");
 require_once($_path["include"]."form.php");

 class Plugin_dashboard extends Base_Plugin
 {
  function main()
  {
   if(!$this->config)
    return false;

   $this->plugin->l->read("module_dashboard_servers");

   if(isset($this->plugin->pager)) //called via pager plugin
   {
    //add dashboard script+style sheet
    $this->plugin->pager->addJavaScript($this->plugin->path["root"]."script/dashboard.js");
    $this->plugin->pager->addStyleSheet($this->plugin->path["root"]."style/dashboard.css");
   }

   //define views
   $this->views=Array(

    "system" => Array(
     "show" => true, 
     "title" => "System", 
     "display" => "horizontalView", 
     "module" => "dashboard_system",
    ),

    "uptime" => Array(
     "show" => true, 
     "title" => "Uptime / Load", 
     "display" => "verticalView", 
     "module" => "dashboard_uptime",
     "graphFields" => Array(
      "users", 
      "load1", 
      "load5", 
      "load15", 
      "activeprocs", 
      "totalprocs", 
     ),
    ),

    "memory" => Array(
     "show" => true, 
     "title" => "Memory usage", 
     "display" => "horizontalView", 
     "module" => "dashboard_memory", 
     "mutilations" => Array(
      "memoryavailable" => Array("humanReadableFileSize" => Array()),
      "memoryavailable_d" => Array("humanReadableFileSize" => Array()),
      "memoryavailable_percentage" => Array("replace" => Array("/^(.+)$/", "\\1%")),
      "memoryavailable_percentage_d" => Array("replace" => Array("/^(.+)$/", "\\1%")),

      "memoryused" => Array("humanReadableFileSize" => Array()),
      "memoryused_d" => Array("humanReadableFileSize" => Array()),
      "memoryused_percentage" => Array("replace" => Array("/^(.+)$/", "\\1%")),
      "memoryused_percentage_d" => Array("replace" => Array("/^(.+)$/", "\\1%")),

      "memorycached" => Array("humanReadableFileSize" => Array()),
      "memorycached_d" => Array("humanReadableFileSize" => Array()),
      "memorycached_percentage" => Array("replace" => Array("/^(.+)$/", "\\1%")),
      "memorycached_percentage_d" => Array("replace" => Array("/^(.+)$/", "\\1%")),

      "memorybuffers" => Array("humanReadableFileSize" => Array()),
      "memorybuffers_d" => Array("humanReadableFileSize" => Array()),
      "memorybuffers_percentage" => Array("replace" => Array("/^(.+)$/", "\\1%")),
      "memorybuffers_percentage_d" => Array("replace" => Array("/^(.+)$/", "\\1%")),

      "memorytotal" => Array("humanReadableFileSize" => Array()),

      "swapavailable" => Array("humanReadableFileSize" => Array()),
      "swapavailable_d" => Array("humanReadableFileSize" => Array()),
      "swapavailable_percentage" => Array("replace" => Array("/^(.+)$/", "\\1%")),
      "swapavailable_percentage_d" => Array("replace" => Array("/^(.+)$/", "\\1%")),

      "swapused" => Array("humanReadableFileSize" => Array()),
      "swapused_d" => Array("humanReadableFileSize" => Array()),
      "swapused_percentage" => Array("replace" => Array("/^(.+)$/", "\\1%")),
      "swapused_percentage_d" => Array("replace" => Array("/^(.+)$/", "\\1%")),

      "swapcached" => Array("humanReadableFileSize" => Array()),
      "swapcached_d" => Array("humanReadableFileSize" => Array()),
      "swapcached_percentage" => Array("replace" => Array("/^(.+)$/", "\\1%")),
      "swapcached_percentage_d" => Array("replace" => Array("/^(.+)$/", "\\1%")),

      "swaptotal" => Array("humanReadableFileSize" => Array()),
     ),
    ),

    "network" => Array(
     "show" => true, 
     "title" => "Network", 
     "display" => "verticalView", 
     "module" => "dashboard_network", 
     "mutilations" => Array(
      "device" => Array("icon" => Array()),

      "rx" => Array("humanReadableFileSize" => Array()),
      "rx_dps" => Array("humanReadableFileSize" => Array(), "replace" => Array("/^(.+)$/", "\\1/s")),

      "tx" => Array("humanReadableFileSize" => Array()),
      "tx_dps" => Array("humanReadableFileSize" => Array(), "replace" => Array("/^(.+)$/", "\\1/s")),
     ),
     "graphFields" => Array(
      "device", 
     ),
    ),

    "diskspace" => Array(
     "show" => true, 
     "title" => "Disk space", 
     "display" => "verticalView", 
     "module" => "dashboard_diskspace", 
     "mutilations" => Array(
      "mountpoint" => Array("icon" => Array()),

      "available" => Array("humanReadableFileSize" => Array()),
      "available_d" => Array("humanReadableFileSize" => Array()),
      "available_percentage" => Array("replace" => Array("/^(.+)$/", "\\1%")),
      "available_percentage_d" => Array("replace" => Array("/^(.+)$/", "\\1%")),

      "used" => Array("humanReadableFileSize" => Array()),
      "used_d" => Array("humanReadableFileSize" => Array()),
      "used_percentage" => Array("replace" => Array("/^(.+)$/", "\\1%")),
      "used_percentage_d" => Array("replace" => Array("/^(.+)$/", "\\1%")),

      "missing" => Array("humanReadableFileSize" => Array()),
      "missing_percentage" => Array("replace" => Array("/^(.+)$/", "\\1%")),

      "total" => Array("humanReadableFileSize" => Array()),
     ),
     "graphFields" => Array(
      "mountpoint", 
     ),
    ),

    "diskstats" => Array(
     "show" => true, 
     "title" => "Disk statistics", 
     "display" => "verticalView", 
     "module" => "dashboard_diskstats", 
     "mutilations" => Array(
     ),
     "graphFields" => Array(
      "device", 
     ),
    ),

    "sensors" => Array(
     "show" => true, 
     "title" => "Sensors", 
     "display" => "verticalView", 
     "module" => "dashboard_sensors", 
     "mutilations" => Array(
     ),
     "graphFields" => Array(
      "device", 
     ),
    ),
   );


   //get server list for current config
   $dpcs=Data::cache("dashboard_pluginConfigs", "view", "item");
   $dpcs->setShowFields("nr", "dashboard_pluginConfigsServers", "dashboard_pluginConfigsAllowedServers", "pluginConfigsServerPages");
   $dpcs->clearValues();

   $dpcs->setValue("nr", $this->config["nr"]);

   if(!$dpcs->get())
   {
    $this->e->add($dpcs->e);
    return false;
   }

   //get servers
   $this->servers=Array();
   $ds=Data::cache("dashboard_servers", "view", "all");
   $ds->sortOrder("key+");
   $ds->clearValues();

   $c=0;
   $servers=Array();
   foreach($dpcs->getValue("dashboard_pluginConfigsServers") as $server) //dashboard servers
   {
    $ds->setValue("nr", $server, $c);
    $ds->setOperant("nr", "OR", $c);
    $servers[]=$server;
    $c++;
   }

   foreach($dpcs->getValue("dashboard_pluginConfigsAllowedServers") as $server) //allowed servers
   {
    if(!in_array($server, $servers))
    {
     $ds->setValue("nr", $server, $c);
     $ds->setOperant("nr", "OR", $c);
     $servers[]=$server;
     $c++;
    }
   }

   if(!$ds->get())
   {
    $this->e->add($ds->e);
    return false;
   }

   while($ds->next())
   {
    $name=$ds->v["name"];
    $this->servers[$name]=$ds->v;
    $this->servers[$name]["show"]=false;
    $this->servers[$name]["icons"]=Array();
    $this->servers[$name]["uri"]="dashboard_cli://";

    if(in_array($ds->v["nr"], $dpcs->getValue("dashboard_pluginConfigsServers")))
     $this->servers[$name]["dashboard"]=true;
    else
     $this->servers[$name]["dashboard"]=false;

    if(in_array($ds->v["nr"], $dpcs->getValue("dashboard_pluginConfigsAllowedServers")))
     $this->servers[$name]["allowed"]=true;
    else
     $this->servers[$name]["allowed"]=false;

    if(in_array($ds->v["nr"], $dpcs->getValue("dashboard_pluginConfigsAllowedServers")))
     $this->servers[$name]["allowed"]=true;
    else
     $this->servers[$name]["allowed"]=false;

    if($ds->v["method"]=="SNMP")
     $this->servers[$name]["uri"].=$ds->v["username"].($ds->v["password"]?":".$ds->v["password"]:"")."@".$ds->v["hostname"].":".$ds->v["port"]."/snmp/".($ds->v["passphrase"]?"#".$ds->v["passphrase"]:"");
    else if($ds->v["method"]=="SSH")
     $this->servers[$name]["uri"].=$ds->v["username"]."@".$ds->v["hostname"].":".$ds->v["port"]."/ssh/";
    //else //local

    //gather device icons
    foreach(array_keys($ds->moduleObject->modules) as $module)
    {
     if(isset($ds->v[$module."DevicesType"])&&($values=$ds->v[$module."DevicesType"]))
     {
      foreach($values as $deviceType)
      {
       if($deviceType)
       {
        list($device, $type)=explode("=", $deviceType);
 
        $this->servers[$name]["icons"][$device]=Array(
         "type" => $type,
         "title" => $ds->moduleObject->modules[$module]["devices"]["types"][$type],
         "filename" => $module.".".trim($type).".png",
        );
       }
      }
     }
    }

    //gather graph links
    $this->servers[$name]["graphPage"]=false;
    if($values=$dpcs->getValue("pluginConfigsServerPages"))
    {
     foreach($values as $value)
     {
      list($server, $page)=explode("=", $value);

      if($server==$this->servers[$name]["nr"])
      {
       $this->servers[$name]["graphPage"]=$page;
       break;
      }
     }
    }
   }

   //look up server page names
   $dp=Data::cache("pager_categories", "view", "all");
   $dp->setShowFields("nr", "urlname");
   $dp->clearValues();

   $c=0;
   foreach(array_keys($this->servers) as $name)
   {
    if($this->servers[$name]["graphPage"]) 
    {
     $dp->setValue("nr", $this->servers[$name]["graphPage"], $c);
     $dp->setOperator("nr", "=", $c);
     $dp->setOperant("nr", "OR", $c);
     $c++;
    }
   }

   if($dp->get())
   {
    foreach(array_keys($this->servers) as $name)
    {
     if($this->servers[$name]["graphPage"]) 
     {
      $dp->reset();
      while($dp->next())
      {
       if($dp->v["nr"]==$this->servers[$name]["graphPage"])
       {
        $this->servers[$name]["graphPage"]=$dp->v["urlname"];
        break;
       }
      }
     }
    }
   }
   unset($dp);

   //form handling
   if(($servers=request("servers"))) //use select servers
   {
    $this->mode="full";

    //show select servers 
    if(!is_array($servers))
     $servers=array_keys($this->servers);

    foreach($servers as $name)
     if(isset($this->servers[$name]))
      $this->servers[$name]["show"]=true;
   }
   else //no form submitted, use default config
   {
    $this->mode="dashboard";

    //show configured servers 
    foreach(array_keys($this->servers) as $name)
     if($this->servers[$name]["dashboard"]) //only show dashboard servers in dashboard mode
      $this->servers[$name]["show"]="dashboard";
   }

   if(!($views=request("views"))||!is_array($views)) //no views (properly) selected
   {
    $views=Array();

    //use configured views
    foreach(array_keys($this->views) as $view)
     if($this->config[$view])
      $views[]=$view;
   }

   //show selected views
   foreach(array_keys($this->views) as $view)
    if(!in_array($view, $views))
     $this->views[$view]["show"]=false;

   unset($servers, $views);

   //auto update
   if(request("update")===NULL||request("update")==1) //update by default and if update=true
    $this->update=true;
   else
    $this->update=false;

   //setup views
   foreach($this->views as $view => $info)
   {
    if(!$info["show"]) //don't show this view
     continue;

    //unique field name for view in case of multiple lines
    if(isset($ds->moduleObject->modules[$view]["devices"]))
     $this->views[$view]["deviceField"]=$ds->moduleObject->modules[$view]["devices"]["field"];

    //get view data
    $this->$view=Data::cache($info["module"], "view", "all", Array("db" => "dashboard_cli://"));
    $this->$view->addField("_server", "text", "show", false, false, 25, "", "System");
    $this->$view->setShowFields("_server");
    $this->$view->clearValues();

    $d=clone $this->$view;

    //merge $view info of all $views
    $vc=0;
    foreach($this->servers as $name => $server)
    {
     if(!$server["show"]||!$server[$view]) //don't show this server or this server's view
      continue;

     $d->storageSwitch($server["uri"]);
     $d->clearValues();

     //filter devices
     if(isset($ds->moduleObject->modules[$view]["devices"]))
     {
      if($this->mode=="dashboard") //use dashboard config
      {
       $devices=Array();
       foreach($this->config[$view."Devices"] as $serverDevices)
       {
        $serverDevices=explode(" ", $serverDevices, 2); //first is the server number

        if($serverDevices[0]==$server["nr"])
         $devices[]=$serverDevices[1];
       }
      }
      else //use server settings
       $devices=$server[$view."Devices"];

      if(!$devices) //no devices, next server
       continue;

      $c=0;
      foreach($devices as $device)
      {
       $d->setValue($ds->moduleObject->modules[$view]["devices"]["field"], $device, $c);
       $d->setOperator($ds->moduleObject->modules[$view]["devices"]["field"], "=", $c);
       $d->setOperant($ds->moduleObject->modules[$view]["devices"]["field"], "OR", $c);
       $c++;
      }
     }


     //get show fields (and _min+_max) from server
     $fields=Array();
     $dataFields=Array();

     if($this->mode=="dashboard") //use dashboard config
      $displayFields=$this->config[$view."Fields"];
     else //use server settings
      $displayFields=$server[$view."Fields"];

     if(isset($this->views[$view]["deviceField"]))
      $dataFields[]=$this->views[$view]["deviceField"];

     foreach($displayFields as $field)
     {
      $fields[]=$field;

      //get min/max fields for hiliting, displaying is done only if set in server
      if(isset($d->field[$field."_min"]))
       $dataFields[]=$field."_min";
      if(isset($d->field[$field."_max"]))
       $dataFields[]=$field."_max";
     }
     $l=sizeof($fields);

     $d->setShowFields(array_merge($fields, $dataFields)); //set show fields, include min/max values
     $this->$view->setShowFields(array_merge($this->$view->check("use", "show"), $fields)); //merge show fields with global view 

     if(!$d->get())
      $this->e->add($d->e);

     //merge data 
     while($d->next())
     {
      $this->$view->setValue("_server", $name, $vc);

      for($c=0;$c<$l;$c++)
       if(isset($d->v[$fields[$c]]))
        $this->$view->setValue($fields[$c], $d->v[$fields[$c]], $vc);

      foreach($dataFields as $field)
       $this->$view->setValue($field, $d->v[$field], $vc);

      $vc++;
     }
    }

    //resort $view info
    if($sort=request("sort", $view))
    {
     $this->$view->sortOrder(explode(";", $sort));
     $this->$view->resort();
    }
   }

   return true;
  }



  function output()
  {
   $r="<div class=\"dashboard\">\n";

   $r.=" <h1>".$this->plugin->l->t("Dashboard")."</h1>\n";

   //form
   $r.=" <div class=\"form\">\n";

   $f=new Form();
   $r.=$f->start();

   $show=Array();
   foreach($this->servers as $name => $server)
    if($this->mode=="full"&&$server["show"])
     $show[]=$name;

   $allowed=Array();
   foreach($this->servers as $name => $server)
    if($server["allowed"])
     $allowed[]=$name;

   $r.=" <div class=\"menu servers\">\n";
   $r.=" <h3>".$this->plugin->l->t("Servers")."</h3>\n";
   $r.=$f->listview("multiple", "servers[]", $allowed, $show, false, false, "onchange=\"this.form.submit();\"");
   $r.=" </div>\n";

   $show=Array();
   $views=Array();
   foreach(array_keys($this->views) as $view)
   {
    $views[$view]=$this->views[$view]["title"];

    if($this->views[$view]["show"])
     $show[]=$view;
   }

   $r.=" <div class=\"menu views\">\n";
   $r.=" <h3>".$this->plugin->l->t("Views")."</h3>\n";
   $r.=$f->listview("multiple", "views[]", $views, $show, false, false, "onchange=\"this.form.submit();\"");
   $r.=" </div>\n";

   $r.=" <div class=\"menu update\">\n";
   $r.=$f->input("hidden", "update", "0");
   $r.=$f->checkbox($this->update, "Update", "update", "1", false, "update", "onchange=\"if(this.checked){db.start();}else{db.stop();}\"");
   $r.=" </div>\n";

   $r.=$f->end();

   $r.=" <div class=\"menu legend\">\n";
   $r.=" <table class=\"legend\">\n";
   $r.=" <tr><th>".$this->plugin->l->t("Legend")."</th></tr>\n";
   $r.="  <tr><td class=\"normal\">".$this->plugin->l->t("Normal")."</td></tr>\n";
   $r.="  <tr><td class=\"outdated\">".$this->plugin->l->t("Outdated")."</td></tr>\n";
   $r.="  <tr><td class=\"deltaup\">".$this->plugin->l->t("Delta up")."</td></tr>\n";
   $r.="  <tr><td class=\"deltadown\">".$this->plugin->l->t("Delta down")."</td></tr>\n";
   $r.="  <tr><td class=\"min\">".$this->plugin->l->t("Minimum")."</td></tr>\n";
   $r.="  <tr><td class=\"max\">".$this->plugin->l->t("Maximum")."</td></tr>\n";
   $r.=" </table>\n";
   $r.=" </div>\n";

   $r.=" <br style=\"clear: both;\"/>\n";
   $r.=" </div>\n";


   //show views
   foreach($this->views as $view => $info)
   {
    if($info["show"])
    {
     if($this->$view->values()==1||$this->mode=="dashboard") //single line, use horizontal display mode
      $r.=$this->horizontalView($view);
     else if($this->$view->values()>=1) //multi line, use defined display mode
     {
      $display=$info["display"];
      $r.=$this->$display($view);
     }
    }
   }

   $r.="</div>\n";
   return $r;
  }



  function horizontalView($view)
  {
   global $_path;

   //get data object
   $d=&$this->$view;

   //get show fields
   $fields=Array();
   foreach($d->check("use", "show") as $field)
   {
    if($field=="r"||$field=="_server")
     continue;

    $fields[]=$field;
   }
   $l=sizeof($fields);


   $r="";

   //add device field 
   if(isset($this->views[$view]["deviceField"])) 
    $r.="<input type=\"hidden\" name=\"deviceField\" value=\"".$this->views[$view]["deviceField"]."\"/>";

   //set up header
   $r.="<table class=\"".$view." horizontal ".($d->values()>1?"multi":"single").($this->mode=="dashboard"?" dashboardmode":"")."\">\n";
   $r.=" <tr class=\"head\">\n";
   $r.="  <th class=\"".$view."\">";
   $r.="   <a href=\"".$_path["HTML"]["url"]."?servers[]=".join("&amp;servers[]=", array_keys($this->servers))."&amp;views[]=".$view."&amp;update=".($this->update?1:0)."\" onclick=\"this.href=this.href.replace(/update=[0-9]/, 'update='+(document.getElementById('update').checked?1:0));\" title=\"".$this->plugin->l->t($this->views[$view]["title"])." details\"><img src=\"".$this->plugin->path["root"]."images/".$view.".png\" alt=\"".$this->views[$view]["title"]."\" class=\"icon\" /></a>";
   $r.="   ".$this->plugin->l->t($this->views[$view]["title"]);
   $r.="  </th>\n";

   //add field titles
   $colspan=1;
   while($d->next())
   {
    //merge field headers with same title
    if($d->vc>=$d->vmax||$d->v["_server"]!=$d->getValue("_server", $d->vc)) //last or next title different?
    {
     $r.="  <td class=\"_server\" id=\"".$view."_".$d->v["_server"]."__server"."\"".($colspan>1?" colspan=\"".$colspan."\"":"").">";
     $r.=$d->v["_server"];
     $r.=" <a href=\"".$_path["HTML"]["url"]."?servers[]=".$d->v["_server"]."&amp;views[]=".$view."&amp;update=".($this->update?1:0)."\" onclick=\"this.href=this.href.replace(/update=[0-9]/, 'update='+(document.getElementById('update').checked?1:0));\" title=\"".$this->plugin->l->t($this->views[$view]["title"])." details for ".$d->v["_server"]."\"><img src=\"".$this->plugin->path["root"]."images/details.png\" alt=\"Details\" class=\"icon small details\" /></a>";
     $r.="</td>\n";

     $colspan=1;
    }
    else
     $colspan++; 
   }

   $r.=" </tr>\n";


   //render data + field titles
   $rowspan=0;
   $lastKey=false;
   for($c=0;$c<$l;$c++) //one field per row
   {
    $r.=" <tr class=\"".($c%2?"odd":"even")."\">\n";

    if($rowspan<1)
    {
     $rowspan=1;
     for($x=$c;$x<$l;$x++)
     {
      if($x+1>=$l||$d->title($fields[$x])!=$d->title($fields[$x+1])) //last or next title different?
       break;
      else //same title
       $rowspan++;
     }

     $r.="  <th class=\"".$fields[$c]."\"".($rowspan>1?" rowspan=\"".$rowspan."\"":"").">".$d->title($fields[$c])."</th>\n";
    }

    $rowspan--;


    while($d->next()) //all values on the current row
    {
     //generate id
     if(in_array($fields[$c], $this->servers[$d->v["_server"]][$view."Fields"])) //field active for current server view
     {
      $id=$view."_".$d->v["_server"]."_".$fields[$c];

      if(isset($this->views[$view]["deviceField"])) //add device field suffix
       $id.=".".preg_replace("/^\.+/", "", preg_replace("/[^a-z0-9]/i", ".", $d->getValue($this->views[$view]["deviceField"], $d->vc-1))); //replace special characters with ., removing the first dot(s)
     }
     else //not active
      $id=""; //make sure script doesn't update value

     //class name
     $class=$fields[$c]." ".$d->field[$fields[$c]]["type"];

     if(!$id) //don't display for non display field
      $value="&nbsp; ";
     else
     {
      //min / max
      if(isset($d->v[$fields[$c]]))
      {
       if(
        ($d->getValue($fields[$c]."_min", $d->vc-1)!==false&&$d->sqlValue($fields[$c], $d->vc-1)<=$d->sqlValue($fields[$c]."_min", $d->vc-1))|| //dynamic min value
        ($d->field[$fields[$c]]["min"]!==false&&$d->v[$fields[$c]]<=$d->field[$fields[$c]]["min"]) //static min value
       )
        $class.=" min";

       if(
        ($d->getValue($fields[$c]."_max", $d->vc-1)!==false&&$d->sqlValue($fields[$c], $d->vc-1)>=$d->sqlValue($fields[$c]."_max", $d->vc-1))|| //dynamic max value
        ($d->field[$fields[$c]]["max"]!==false&&$d->v[$fields[$c]]>=$d->field[$fields[$c]]["max"]) //static max value
       )
        $class.=" max";
      }


      //get values
      if(!isset($d->v[$fields[$c]])) //no value set
      {
       $value=$d->getDefaultValue($fields[$c]); //use default

       if($value!==false&&$d->field[$fields[$c]]["type"]=="float") //do number format
        $value=number_format(str_replace(Array(" ", ","), Array("", "."), $value), $d->field[$fields[$c]]["format"][$d->dataformat]["decimals"], $d->field[$fields[$c]]["format"][$d->dataformat]["decimalseparator"], $d->field[$fields[$c]]["format"][$d->dataformat]["thousandsseparator"]);
      }
      else if($d->v[$fields[$c]]==="") //empty string
       $value="&nbsp; ";
      else //normal value
       $value=$d->v[$fields[$c]];

      //value mutilations
      if(isset($this->views[$view]["mutilations"])&&isset($this->views[$view]["mutilations"][$fields[$c]]))
      {
       foreach($this->views[$view]["mutilations"][$fields[$c]] as $mutilation => $args)
       {
        switch($mutilation)
        {
         case "humanReadableFileSize":
         {
          if($d->field[$fields[$c]]["type"]=="float")
           $value=str_replace(Array(" ", ","), Array("", "."), $value);

          $value=Mutilate::humanReadableFileSizeS($value, $d->format[$d->dataformat]["decimals"], $d->format[$d->dataformat]["decimalseparator"]);
          $class.=" humanreadable";
          break;
         }
         case "replace":
         {
          $value=Mutilate::replaceS($value, $args[0], $args[1]);
          break;
         }
         case "icon":
         {
          if(isset($this->servers[$d->v["_server"]]["icons"][$d->v[$fields[$c]]]))
           $value=" <img src=\"".$this->plugin->path["root"]."images/".$this->servers[$d->v["_server"]]["icons"][$d->v[$fields[$c]]]["filename"]."\" alt=\"".$this->servers[$d->v["_server"]]["icons"][$d->v[$fields[$c]]]["title"]."\" class=\"icon small\" /> ".$value;

          break;
         }
         default: break;
        }
       }
      }
     }


     $r.="  <td class=\"".$class."\" id=\"".$id."\">";

     //display graph link for field
     if($this->servers[$d->v["_server"]]["graphPage"]&&isset($this->views[$view]["graphFields"])&&in_array($fields[$c], $this->views[$view]["graphFields"])) //server graph page and graph field
     {
      if(isset($this->views[$view]["deviceField"])) //device link
      {
       if($view=="diskstats")
        $r.=" <a href=\"".$_path["HTML"]["root"].$this->servers[$d->v["_server"]]["graphPage"]."/?".$view."Devices[]=".urlencode(str_replace(":", "->", $d->getValue($this->views[$view]["deviceField"], $d->vc-1)))."\" title=\"".$this->plugin->l->t($this->views[$view]["title"])." graph for ".$d->v["_server"]."\"><img src=\"".$this->plugin->path["root"]."images/graph.png\" alt=\"Chart\" class=\"icon small graph\" /></a>";
       else
        $r.=" <a href=\"".$_path["HTML"]["root"].$this->servers[$d->v["_server"]]["graphPage"]."/?".$view."Devices[]=".urlencode($d->getValue($this->views[$view]["deviceField"], $d->vc-1))."\" title=\"".$this->plugin->l->t($this->views[$view]["title"])." graph for ".$d->v["_server"]."\"><img src=\"".$this->plugin->path["root"]."images/graph.png\" alt=\"Chart\" class=\"icon small graph\" /></a>";
      }
      else if($view=="uptime") //field link (load)
        $r.=" <a href=\"".$_path["HTML"]["root"].$this->servers[$d->v["_server"]]["graphPage"]."/?load[]=".urlencode($fields[$c])."\" title=\"".$this->plugin->l->t($this->views[$view]["title"])." graph for ".$d->v["_server"]."\"><img src=\"".$this->plugin->path["root"]."images/graph.png\" alt=\"Chart\" class=\"icon small graph\" /></a>";
      else //field link 
       $r.=" <a href=\"".$_path["HTML"]["root"].$this->servers[$d->v["_server"]]["graphPage"]."/?".$view."Fields[]=".urlencode($fields[$c])."\" title=\"".$this->plugin->l->t($this->views[$view]["title"])." graph for ".$d->v["_server"]."\"><img src=\"".$this->plugin->path["root"]."images/graph.png\" alt=\"Chart\" class=\"icon small graph\" /></a>";
     }

     $r.=$value;

     if(preg_match("/_d(ps)?$/", $fields[$c])) //delta (/s) field
      $r.=" <img src=\"".$this->plugin->path["root"]."images/still.png\" alt=\"Delta\" class=\"icon small delta\" />";

     $r.="</td>\n";
    }

    $r.=" </tr>\n";
   }

   $r.="</table>\n";

   return $r;
  }



  function verticalView($view)
  {
   global $_path;

   $d=&$this->$view;

   //get show fields
   $fields=Array();
   foreach($d->check("use", "show") as $field)
   {
    if($field=="r"||$field=="_server")
     continue;

    $fields[]=$field;
   }
   $l=sizeof($fields);


   $r="";

   //add device field 
   if(isset($this->views[$view]["deviceField"])) 
    $r.="<input type=\"hidden\" name=\"deviceField\" value=\"".$this->views[$view]["deviceField"]."\"/>";

   //set up header
   $r.="<table class=\"".$view." vertical ".($d->values()>1?"multi":"single").($this->mode=="dashboard"?" dashboardmode":"")."\">\n";
   $r.=" <tr class=\"head\">\n";
   $r.="  <th class=\"".$view."\">";
   $r.="   <a href=\"".$_path["HTML"]["url"]."?servers[]=".join("&amp;servers[]=", array_keys($this->servers))."&amp;views[]=".$view."&amp;update=".($this->update?1:0)."\" onclick=\"this.href=this.href.replace(/update=[0-9]/, 'update='+(document.getElementById('update').checked?1:0));\" title=\"".$this->plugin->l->t($this->views[$view]["title"])." details\"><img src=\"".$this->plugin->path["root"]."images/".$view.".png\" alt=\"".$this->views[$view]["title"]."\" class=\"icon\" /></a>";
   $r.="   ".$this->plugin->l->t($this->views[$view]["title"]);
   $r.="  </th>\n";


   //add field titles
   $colspan=1;
   for($c=0;$c<$l;$c++)
   {
    //merge field headers with same title
    if($c+1>=$l||$d->title($fields[$c])!=$d->title($fields[$c+1])) //last or next title different?
    {
     $r.="  <th class=\"".$fields[$c]."\"".($colspan>1?" colspan=\"".$colspan."\"":"").">".$d->title($fields[$c])."</th>\n";
     $colspan=1;
    }
    else //same title
     $colspan++;
   }

   $r.=" </tr>\n";


   //render data
   $lastKey=false;
   while($d->next()) //one value set per row
   {
    $r.=" <tr class=\"".$d->v["_server"]." ".($d->vc%2?"odd":"even")."\">\n";

    //determine field suffix: 0, 1, 2, etc for each server the counter resets 
    if($lastKey!=$d->v["_server"])
    {
     $lastKey=$d->v["_server"];

     //determine rowspan for _server
     $rowspan=1;
     for($vc=$d->vc;$vc<$d->vmax;$vc++)
     {
      if($d->v["_server"]!=$d->getValue("_server", $vc))
       break;

      $rowspan++;
     }

     $r.="  <td class=\"_server\" id=\"".$view."_".$d->v["_server"]."__server"."\"".($rowspan>1?" rowspan=\"".$rowspan."\"":"").">";
     $r.=$d->v["_server"];
     $r.=" <a href=\"".$_path["HTML"]["url"]."?servers[]=".$d->v["_server"]."&amp;views[]=".$view."&amp;update=".($this->update?1:0)."\" onclick=\"this.href=this.href.replace(/update=[0-9]/, 'update='+(document.getElementById('update').checked?1:0));\" title=\"".$this->plugin->l->t($this->views[$view]["title"])." details for ".$d->v["_server"]."\"><img src=\"".$this->plugin->path["root"]."images/details.png\" alt=\"Details\" class=\"icon small details\" /></a>";
     $r.="</td>\n";
    }

    for($c=0;$c<$l;$c++) //all fields on current row
    {
     //generate id
     if(in_array($fields[$c], $this->servers[$d->v["_server"]][$view."Fields"])) //field active for current server view
     {
      $id=$view."_".$d->v["_server"]."_".$fields[$c];

      if(isset($this->views[$view]["deviceField"])) //add device field suffix
       $id.=".".preg_replace("/^\.+/", "", preg_replace("/[^a-z0-9]/i", ".", $d->getValue($this->views[$view]["deviceField"], $d->vc-1))); //replace special characters with ., removing the first dot(s)
     }
     else //not active
      $id=""; //make sure script doesn't update value

     //class name
     $class=$fields[$c]." ".$d->field[$fields[$c]]["type"];

     if(!$id) //don't display for non display field
      $value="&nbsp; ";
     else
     {
      //min / max
      if(isset($d->v[$fields[$c]])&&($d->field[$fields[$c]]["type"]=="nr"||$d->field[$fields[$c]]["type"]=="float"))
      {
       if(
        ($d->getValue($fields[$c]."_min", $d->vc-1)!==false&&$d->sqlValue($fields[$c], $d->vc-1)<=$d->sqlValue($fields[$c]."_min", $d->vc-1))|| //dynamic min value
        ($d->field[$fields[$c]]["min"]!==false&&$d->v[$fields[$c]]<=$d->field[$fields[$c]]["min"]) //static min value
       )
        $class.=" min";

       if(
        ($d->getValue($fields[$c]."_max", $d->vc-1)!==false&&$d->sqlValue($fields[$c], $d->vc-1)>=$d->sqlValue($fields[$c]."_max", $d->vc-1))|| //dynamic max value
        ($d->field[$fields[$c]]["max"]!==false&&$d->v[$fields[$c]]>=$d->field[$fields[$c]]["max"]) //static max value
       )
        $class.=" max";
      }


      //get values
      if(!isset($d->v[$fields[$c]])) //no value set
      {
       $value=$d->getDefaultValue($fields[$c]); //use default

       if($value!==false&&$d->field[$fields[$c]]["type"]=="float") //do number format
        $value=number_format(str_replace(Array(" ", ","), Array("", "."), $value), $d->field[$fields[$c]]["format"][$d->dataformat]["decimals"], $d->field[$fields[$c]]["format"][$d->dataformat]["decimalseparator"], $d->field[$fields[$c]]["format"][$d->dataformat]["thousandsseparator"]);
      }
      else if($d->v[$fields[$c]]==="") //empty string
       $value="&nbsp; ";
      else //normal value
       $value=$d->v[$fields[$c]];

      //value mutilations
      if(isset($this->views[$view]["mutilations"])&&isset($this->views[$view]["mutilations"][$fields[$c]]))
      {
       foreach($this->views[$view]["mutilations"][$fields[$c]] as $mutilation => $args)
       {
        switch($mutilation)
        {
         case "humanReadableFileSize":
         {
          if($d->field[$fields[$c]]["type"]=="float")
           $value=str_replace(Array(" ", ","), Array("", "."), $value);

          $value=Mutilate::humanReadableFileSizeS($value, $d->format[$d->dataformat]["decimals"], $d->format[$d->dataformat]["decimalseparator"]);
          $class.=" humanreadable";
          break;
         }
         case "replace":
         {
          $value=Mutilate::replaceS($value, $args[0], $args[1]);
          break;
         }
         case "icon":
         {
          if(isset($this->servers[$d->v["_server"]]["icons"][$d->v[$fields[$c]]]))
           $value=" <img src=\"".$this->plugin->path["root"]."images/".$this->servers[$d->v["_server"]]["icons"][$d->v[$fields[$c]]]["filename"]."\" alt=\"".$this->servers[$d->v["_server"]]["icons"][$d->v[$fields[$c]]]["title"]."\" class=\"icon small\" /> ".$value;

          break;
         }
         default: break;
        }
       }
      }
     }


     $r.="  <td class=\"".$class."\" id=\"".$id."\">";

     //display graph link for field
     if($this->servers[$d->v["_server"]]["graphPage"]&&isset($this->views[$view]["graphFields"])&&in_array($fields[$c], $this->views[$view]["graphFields"])) //server graph page and graph field
     {
      if(isset($this->views[$view]["deviceField"])) //device link
      {
       if($view=="diskstats")
        $r.=" <a href=\"".$_path["HTML"]["root"].$this->servers[$d->v["_server"]]["graphPage"]."/?".$view."Devices[]=".urlencode(str_replace(":", "->", $d->getValue($this->views[$view]["deviceField"], $d->vc-1)))."\" title=\"".$this->plugin->l->t($this->views[$view]["title"])." graph for ".$d->v["_server"]."\"><img src=\"".$this->plugin->path["root"]."images/graph.png\" alt=\"Chart\" class=\"icon small graph\" /></a>";
       else
        $r.=" <a href=\"".$_path["HTML"]["root"].$this->servers[$d->v["_server"]]["graphPage"]."/?".$view."Devices[]=".urlencode($d->getValue($this->views[$view]["deviceField"], $d->vc-1))."\" title=\"".$this->plugin->l->t($this->views[$view]["title"])." graph for ".$d->v["_server"]."\"><img src=\"".$this->plugin->path["root"]."images/graph.png\" alt=\"Chart\" class=\"icon small graph\" /></a>";
      }
      else if($view=="uptime") //field link (load)
        $r.=" <a href=\"".$_path["HTML"]["root"].$this->servers[$d->v["_server"]]["graphPage"]."/?load[]=".urlencode($fields[$c])."\" title=\"".$this->plugin->l->t($this->views[$view]["title"])." graph for ".$d->v["_server"]."\"><img src=\"".$this->plugin->path["root"]."images/graph.png\" alt=\"Chart\" class=\"icon small graph\" /></a>";
      else //field link 
       $r.=" <a href=\"".$_path["HTML"]["root"].$this->servers[$d->v["_server"]]["graphPage"]."/?".$view."Fields[]=".urlencode($fields[$c])."\" title=\"".$this->plugin->l->t($this->views[$view]["title"])." graph for ".$d->v["_server"]."\"><img src=\"".$this->plugin->path["root"]."images/graph.png\" alt=\"Chart\" class=\"icon small graph\" /></a>";
     }

     $r.=$value;

     if(preg_match("/_d(ps)?$/", $fields[$c])) //delta (/s) field
      $r.=" <img src=\"".$this->plugin->path["root"]."images/still.png\" alt=\"Delta\" class=\"icon small delta\" />";

     $r.="</td>\n";
    }

    $r.=" </tr>\n";
   }

   $r.="</table>\n";

   return $r;
  }

 }
?>
