<?

 /*************************************************************************************
 * Filename: modules/dashboard.php
 *
 * This file is part of the Dashboard JAS plugin.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The Dashboard JAS plugin is free software under the terms of the
 * GNU General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the plugin or http://jas.junerules.com/plugins/dashboard/
 *************************************************************************************/


 require_once($_path["include"]."module.php");

 class Plugin_Module_dashboard_dashboard extends Module
 {
  function __construct(&$data)
  {
   global $_path;

   parent::__construct($data);

   $this->data->title="Dashboard module";

   $this->deviceList=Array();
  }

  function postInit()
  {
   return $this->customDB();
  }

  function customDB()
  {
   if(preg_match("!dashboard_cli://\?([^\]]+)!", $this->data->db, $m))
   {
    $view=str_replace("dashboard_", "", $this->data->module);

    $d=Data::cache("dashboard_servers", "view", "all");
    $d->setShowfields("method", "hostname", "port", "username", "password", "passphrase", $view."Devices");
    $d->clearValues();

    $d->setValue("name", $m[1]);

    if(!$d->get()||!$d->next())
    {
     $this->data->e->add("Getting dashboard ".$view." failed, server: \"".$m[1]."\" not found", "error");
     return false;
    }

    $this->data->db="dashboard_cli://";

    if($d->v["method"]=="SNMP")
     $this->data->db.=$d->v["username"].($d->v["password"]?":".$d->v["password"]:"")."@".$d->v["hostname"].":".$d->v["port"]."/snmp/".($d->v["passphrase"]?"?passphrase=".$d->v["passphrase"]:"");
    else if($d->v["method"]=="SSH")
     $this->data->db.=$d->v["username"]."@".$d->v["hostname"].":".$d->v["port"]."/ssh/";
    //else //local

    //save device list
    $this->deviceList["view"]=$view;
    if(isset($d->moduleObject->modules[$view]["devices"]))
    {
     $this->deviceList["devices"]=$d->v[$view."Devices"];
     $this->deviceList["field"]=$d->moduleObject->modules[$view]["devices"]["field"];
    }
    else
     $this->deviceList["devices"]=Array();
   }

   return true;
  }

  function viewPreGetErrorCheck()
  {
   if($this->data->extra!="all") //don't bother for non view->all
    return true;

   //do device filtering
   if($this->deviceList) //device list implies custom DB
   {
    $c=0;
    foreach($this->deviceList["devices"] as $device)
    {
     $this->data->setValue($this->deviceList["field"], $device, $c);
     $this->data->setOperator($this->deviceList["field"], "=", $c);
     $this->data->setOperant($this->deviceList["field"], "OR", $c);
     $c++;
    }
   }

   return true;
  }

 }
?>
