<?

 /*************************************************************************************
 * Filename: modules/diskspace.php
 *
 * This file is part of the Dashboard JAS plugin.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The Dashboard JAS plugin is free software under the terms of the
 * GNU General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the plugin or http://jas.junerules.com/plugins/dashboard/
 *************************************************************************************/


 require_once($_path["include"]."module.php");
 require_once($_path["project"]["plugins"]."dashboard/modules/dashboard.php");

 class Plugin_Module_dashboard_diskspace extends Plugin_Module_dashboard_dashboard
 {
  function __construct(&$data)
  {
   global $_path;

   parent::__construct($data);

   $this->data->title="Dashboard disk space";

   $this->data->addField("mountpoint", "text", "show;sql", "title", false, 25, false, "Mount point");

   $this->data->addField("available", "nr", "all", "big", 1000000000, false, 0, "Bytes available"); //minimal 1GB
   $this->data->addField("available_d", "float", "show", false, false, false, 0, "Bytes available");
   $this->data->addField("available_percentage", "float", "all", false, 5, false, 0, "Bytes available"); //minimal 5%
   $this->data->addField("available_percentage_d", "float", "show", false, false, false, 0, "Bytes available");

   $this->data->addField("used", "nr", "all", "big", false, false, 0, "Bytes used");
   $this->data->addField("used_d", "float", "show", false, false, false, 0, "Bytes used");
   $this->data->addField("used_percentage", "float", "all", false, false, false, 0, "Bytes used");
   $this->data->addField("used_percentage_d", "float", "show", false, false, false, 0, "Bytes used");

   $this->data->addField("missing", "nr", "all", "big", false, false, 0, "Bytes missing");
   $this->data->addField("missing_percentage", "float", "all", false, false, false, 0, "Bytes missing");

   $this->data->addField("total", "nr", "all", "big", false, false, 0, "Total bytes");

   $this->data->addField("filesystem", "text", "show;sql", false, false, 25, false, "File system");
   $this->data->addField("device", "text", "show;sql", false, false, 25, false, "Device");

   $this->data->addField("updated", "datetime", "sql", "forceUpdate;default", false, false, "now", "Last update");

   $this->data->sortOrder("mountpoint+");
  }
 }
?>
