<?

 /*************************************************************************************
 * Filename: modules/diskstats.php
 *
 * This file is part of the Dashboard JAS plugin.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The Dashboard JAS plugin is free software under the terms of the
 * GNU General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the plugin or http://jas.junerules.com/plugins/dashboard/
 *************************************************************************************/


 require_once($_path["include"]."module.php");
 require_once($_path["project"]["plugins"]."dashboard/modules/dashboard.php");

 class Plugin_Module_dashboard_diskstats extends Plugin_Module_dashboard_dashboard
 {
  function __construct(&$data)
  {
   global $_path;

   parent::__construct($data);

   $this->data->title="Dashboard disk statistics";

   $this->data->addField("device", "text", "all", false, false, 50, false, "Device");
   $this->data->addField("family", "text", "all", false, false, 50, false, "Family");
   $this->data->addField("model", "text", "all", false, false, 50, false, "Model");
   $this->data->addField("attributenr", "nr", "all", false, false, 25, false, "Attribute number");
   $this->data->addField("attribute", "text", "all", false, false, 25, false, "Attribute");
   $this->data->addField("deviceattribute", "text", "sql", false, false, 25, false, "Device attribute");

   $this->data->addField("value", "nr", "all", false, false, false, 0, "Value");
   $this->data->addField("value_d", "nr", "show", false, false, false, 0, "Value");

   $this->data->addField("value_min", "float", "all", false, false, false, false, "Minimum value");
   $this->data->addField("value_max", "float", "all", false, false, false, false, "Maximum value");

   $this->data->addField("unit", "text", "all", false, false, 10, false, "Unit");

   $this->data->addField("updated", "datetime", "sql", "forceUpdate;default", false, false, "now", "Last update");

   $this->data->sortOrder("device+", "attributenr+");

   $this->data->addMutilation("attributenr", "leadingZeros", 3);
  }
 }
?>
