<?

 /*************************************************************************************
 * Filename: modules/sensors.php
 *
 * This file is part of the Dashboard JAS plugin.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The Dashboard JAS plugin is free software under the terms of the
 * GNU General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the plugin or http://jas.junerules.com/plugins/dashboard/
 *************************************************************************************/


 require_once($_path["include"]."module.php");
 require_once($_path["project"]["plugins"]."dashboard/modules/dashboard.php");

 class Plugin_Module_dashboard_sensors extends Plugin_Module_dashboard_dashboard
 {
  function __construct(&$data)
  {
   global $_path;

   parent::__construct($data);

   $this->data->title="Dashboard sensors";

   $this->data->addField("device", "text", "all", false, false, 50, false, "Device");
   $this->data->addField("adapter", "text", "all", false, false, 50, false, "Adapter");
   $this->data->addField("sensor", "text", "all", false, false, 25, false, "Sensor");
   $this->data->addField("devicesensor", "html", "sql", false, false, 255, false, "Device sensor");

   $this->data->addField("value", "float", "all", false, false, false, 0, "Value");
   $this->data->addField("value_d", "float", "show", false, false, false, 0, "Value");

   $this->data->addField("value_min", "float", "all", false, false, false, false, "Minimum value");
   $this->data->addField("value_max", "float", "all", false, false, false, false, "Maximum value");

   $this->data->addField("unit", "text", "all", false, false, 10, false, "Unit");

   $this->data->addField("updated", "datetime", "sql", "forceUpdate;default", false, false, "now", "Last update");

   $this->data->sortOrder("device+", "adapter+", "sensor+");
  }
 }
?>
