<?

 /*************************************************************************************
 * Filename: modules/uptime.php
 *
 * This file is part of the Dashboard JAS plugin.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The Dashboard JAS plugin is free software under the terms of the
 * GNU General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the plugin or http://jas.junerules.com/plugins/dashboard/
 *************************************************************************************/


 require_once($_path["include"]."module.php");
 require_once($_path["project"]["plugins"]."dashboard/modules/dashboard.php");

 class Plugin_Module_dashboard_uptime extends Plugin_Module_dashboard_dashboard
 {
  function __construct(&$data)
  {
   global $_path;

   parent::__construct($data);

   $this->data->title="Dashboard uptime / load";

   $this->data->addField("updays", "nr", "show;sql", "title", false, 50, 0, "Days"); //max 50 days
   $this->data->addField("uptime", "time", "show;sql", "title", false, false, false, "Time");

   $this->data->addField("users", "nr", "all", false, false, 25, 0, "Users"); //max 25 users
   $this->data->addField("users_d", "nr", "show", false, -5, 5, 0, "Users"); //max 10 new users

   $this->data->addField("load1", "float", "all", false, false, 5, 0, "Load (1 minute average)"); //max load of 5
   $this->data->addField("load1_d", "float", "show", false, false, 1, 0, "Load (1 minute average)"); //max load increment of 1
   $this->data->addField("load5", "float", "all", false, false, 3, 0, "Load (5 minutes average)"); //max load of 3
   $this->data->addField("load5_d", "float", "show", false, false, 0.5, 0, "Load (5 minutes average)"); //max load increment of 0.5
   $this->data->addField("load15", "float", "all", false, false, 2, 0, "Load (15 minutes average)"); //max load of 2
   $this->data->addField("load15_d", "float", "show", false, false, 0.25, 0, "Load (15 minutes average)"); //max load increment of 0.25

   $this->data->addField("activeprocs", "nr", "all", false, false, false, 0, "Active processes");
   $this->data->addField("activeprocs_d", "nr", "show", false, false, 5, 0, "Active processes"); //max active processes increment of 5
   $this->data->addField("totalprocs", "nr", "all", false, false, false, 0, "Total processes");
   $this->data->addField("totalprocs_d", "nr", "show", false, false, 5, 0, "Total processes"); //max total processes increment of 5

   $this->data->addField("updated", "datetime", "sql", "forceUpdate;default", false, false, "now", "Last update");
  }
 }
?>
